unit Main;

interface

uses
  SysUtils, Classes, DBXpress, Provider, SqlExpr, FMTBcd, DBClient, DBLocal, DBLocalS, DB,
  QGraphics, QControls, QForms, QDialogs, QStdCtrls, QButtons, QExtCtrls, QComCtrls, QGrids, QDBGrids;
  
type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    SQLMonitor1: TSQLMonitor;
    Memo1: TMemo;
    Label1: TLabel;               
    Button3: TButton;
    StatusBar1: TStatusBar;
    PGEDataset1: TSQLClientDataSet;
    SQLConnection1: TSQLConnection;
    Panel1: TPanel;
    Label2: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    procedure Button3Click(Sender: TObject);
    procedure SQLConnection1AfterConnect(Sender: TObject);
    procedure SQLConnection1AfterDisconnect(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.Button3Click(Sender: TObject);
begin
  PGEDataset1.Close;
  PGEDataset1.CommandText := Memo1.Lines.Text;
  PGEDataset1.CommandType := ctQuery;
  PGEDataset1.Open;
  PGEDataset1.Edit;
  StatusBar1.Panels[0].Text := 'Query sucessfully executed.'
end;

procedure TForm1.SQLConnection1AfterConnect(Sender: TObject);
begin
  Button1.Caption := 'Disconnect';
end;

procedure TForm1.SQLConnection1AfterDisconnect(Sender: TObject);
begin
  if Button1 <> nil then
    Button1.Caption := 'Connect';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SQLConnection1.Connected := not SQLConnection1.Connected;
  if SQLConnection1.Connected then
  begin
    StatusBar1.Panels[0].Text := 'Connected to the database.';
  end
  else
  begin
    PGEDataset1.Close;
    StatusBar1.Panels[0].Text := 'Disconnected from the database.';
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Errors: Integer;
begin
  Errors := PGEDataset1.ApplyUpdates(-1);
  if Errors > 0 then
    ShowMessage(Format('There were %d errors updating the dataset.', [Errors]))
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := 'Program is ready.'
end;

end.
